## howardhinnant-date 3.0.3+ds

=== CMakeLists.txt ===
#[===================================================================[
   date library by Howard Hinnant

   CMake projects that wish to use this library should consider
   something like the following :

     include( FetchContent )
     FetchContent_Declare( date_src
       GIT_REPOSITORY https://github.com/HowardHinnant/date.git
       GIT_TAG        v3.0.1  # adjust tag/branch/commit as needed
     )
     FetchContent_MakeAvailable(date_src)
     ...
     target_link_libraries (my_target PRIVATE date::date)

#]===================================================================]

cmake_minimum_required( VERSION 3.7 )

project( date VERSION 3.0.3 )
set(ABI_VERSION 3) # used as SOVERSION, increment when ABI changes

get_directory_property( has_parent PARENT_DIRECTORY )

if (POLICY CMP0077)
    # Allow CMake 3.13+ to override options when using FetchContent / add_subdirectory.
    cmake_policy(SET CMP0077 NEW)
endif ()

# Override by setting on CMake command line.
set( CMAKE_CXX_STANDARD 17 CACHE STRING "The C++ standard whose features are requested." )

option( USE_SYSTEM_TZ_DB "Use the operating system's timezone database" OFF )
option( MANUAL_TZ_DB "User will set TZ DB manually by invoking set_install in their code" OFF )
option( USE_TZ_DB_IN_DOT "Save the timezone database in the current folder" OFF )
option( BUILD_SHARED_LIBS  "Build a shared version of library" OFF )
option( ENABLE_DATE_TESTING "Enable unit tests" OFF )
option( DISABLE_STRING_VIEW "Disable string view" OFF )
option( COMPILE_WITH_C_LOCALE "define ONLY_C_LOCALE=1" OFF )
option( BUILD_TZ_LIB "build/install of TZ library" OFF )
option( ENABLE_DATE_INSTALL "Enable install" ON )

if( ENABLE_DATE_TESTING AND NOT BUILD_TZ_LIB )
    message(WARNING "Testing requested, but BUILD_TZ_LIB not ON - forcing the latter")
    set (BUILD_TZ_LIB ON CACHE BOOL "required for testing" FORCE)
endif( )

if( ENABLE_DATE_INSTALL )
  include( GNUInstallDirs )
endif( )

function( print_option OPT )
    if ( NOT DEFINED PRINT_OPTION_CURR_${OPT} OR ( NOT PRINT_OPTION_CURR_${OPT} STREQUAL ${OPT} ) )
        set( PRINT_OPTION_CURR_${OPT} ${${OPT}} CACHE BOOL "" )
        mark_as_advanced(PRINT_OPTION_CURR_${OPT})
        message( "# date: ${OPT} ${${OPT}}" )
    endif( )
endfunction( )

print_option( USE_SYSTEM_TZ_DB )
print_option( MANUAL_TZ_DB )
print_option( USE_TZ_DB_IN_DOT )
print_option( BUILD_SHARED_LIBS  )
print_option( ENABLE_DATE_TESTING )
print_option( DISABLE_STRING_VIEW )

#[===================================================================[
   date (header only) library
#]===================================================================]
add_library( date INTERFACE )
add_library( date::date ALIAS date )
target_include_directories( date INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}> )
# adding header sources just helps IDEs
target_sources( date INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/include>$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>/date/date.h
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/include>$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>/date/solar_hijri.h
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/include>$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>/date/islamic.h
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/include>$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>/date/iso_week.h
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/include>$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>/date/julian.h
)

set(TARGET_HEADERS
    include/date/date.h
    include/date/solar_hijri.h
    include/date/islamic.h
    include/date/iso_week.h
    include/date/julian.h
)

if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.15)
    # public headers will get installed:
    set_target_properties( date PROPERTIES PUBLIC_HEADER "${TARGET_HEADERS}" )
endif ()

# These used to be set with generator expressions,
#
#   ONLY_C_LOCALE=$<IF:$<BOOL:${COMPILE_WITH_C_LOCALE}>,1,0>
#
# which expand in the output target file to, e.g.
#
#   ONLY_C_LOCALE=$<IF:$<BOOL:FALSE>,1,0>
#
# This string is then (somtimes?) not correctly interpreted.
if ( COMPILE_WITH_C_LOCALE )
  # To workaround libstdc++ issue https://github.com/HowardHinnant/date/issues/388
  target_compile_definitions( date INTERFACE ONLY_C_LOCALE=1 )
else()
  target_compile_definitions( date INTERFACE ONLY_C_LOCALE=0 )
endif()
if ( DISABLE_STRING_VIEW )
  target_compile_definitions( date INTERFACE HAS_STRING_VIEW=0 -DHAS_DEDUCTION_GUIDES=0 )
else()
  target_compile_definitions( date INTERFACE HAS_STRING_VIEW=1 )
endif()

#[===================================================================[
   tz (compiled) library
#]===================================================================]
if( BUILD_TZ_LIB )
    add_library( date-tz )
    target_compile_definitions( date-tz PRIVATE BUILD_TZ_LIB=1 )
    target_sources( date-tz
      PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/include>$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>/date/tz.h
      PRIVATE
        include/date/tz_private.h
        src/tz.cpp )
    if ( IOS )
      target_sources( date-tz
        PUBLIC
          $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/include>$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>/date/ios.h
        PRIVATE
          src/ios.mm )
    endif()
    add_library( date::date-tz ALIAS date-tz )
    target_link_libraries( date-tz PUBLIC date )
    target_include_directories( date-tz PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}> )

    if ( USE_SYSTEM_TZ_DB OR MANUAL_TZ_DB )
      target_compile_definitions( date-tz PRIVATE AUTO_DOWNLOAD=0 HAS_REMOTE_API=0 )
    else()
      target_compile_definitions( date-tz PRIVATE AUTO_DOWNLOAD=1 HAS_REMOTE_API=1 )
    endif()

    if ( USE_SYSTEM_TZ_DB AND NOT WIN32 AND NOT MANUAL_TZ_DB )
      target_compile_definitions( date-tz PRIVATE INSTALL=. PUBLIC USE_OS_TZDB=1 )
    else()
      target_compile_definitions( date-tz PUBLIC USE_OS_TZDB=0 )
    endif()

    if ( WIN32 AND BUILD_SHARED_LIBS )
      target_compile_definitions( date-tz PUBLIC DATE_BUILD_DLL=1 )
    endif()

    set(TZ_HEADERS include/date/tz.h)

    if( IOS )
        list(APPEND TZ_HEADERS include/date/ios.h)
    endif( )
    set_target_properties( date-tz PROPERTIES
        POSITION_INDEPENDENT_CODE ON
        PUBLIC_HEADER "${TZ_HEADERS}"
        VERSION "${PROJECT_VERSION}"
        SOVERSION "${ABI_VERSION}" )
    if( NOT MSVC )
        find_package( Threads )
        target_link_libraries( date-tz PUBLIC Threads::Threads )
    endif( )
    if( NOT USE_SYSTEM_TZ_DB AND NOT MANUAL_TZ_DB )
        find_package( CURL REQUIRED )
        target_include_directories( date-tz SYSTEM PRIVATE ${CURL_INCLUDE_DIRS} )
        target_link_libraries( date-tz PRIVATE ${CURL_LIBRARIES} )
    endif( )
endif( )

#[===================================================================[
   installation
#]===================================================================]
if( ENABLE_DATE_INSTALL )
  set( version_config "${CMAKE_CURRENT_BINARY_DIR}/dateConfigVersion.cmake" )

  include( CMakePackageConfigHelpers )
  write_basic_package_version_file( "${version_config}"
      VERSION ${PROJECT_VERSION}
      COMPATIBILITY SameMajorVersion )

  install( TARGETS date
      EXPORT dateConfig
      PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/date )
  export( TARGETS date NAMESPACE date:: FILE dateTargets.cmake )
  if (CMAKE_VERSION VERSION_LESS 3.15)
      install(
          FILES ${TARGET_HEADERS}
          DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/date )
  endif ()

  if( BUILD_TZ_LIB )
      install( TARGETS date-tz
          EXPORT dateConfig
          PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/date
          ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
          LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
          RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} )  # This is for Windows
      export( TARGETS date-tz NAMESPACE date:: APPEND FILE dateTargets.cmake )
  endif( )

  if( WIN32 AND NOT CYGWIN)
      set( CONFIG_LOC CMake )
  else( )
      set( CONFIG_LOC "${CMAKE_INSTALL_LIBDIR}/cmake/date" )
  endif( )
  install( EXPORT dateConfig
    FILE dateTargets.cmake
    NAMESPACE date::
    DESTINATION ${CONFIG_LOC} )
  install (
    FILES cmake/dateConfig.cmake "${version_config}"
    DESTINATION ${CONFIG_LOC})
endif( )

#[===================================================================[
   testing
#]===================================================================]
if( ENABLE_DATE_TESTING )
    enable_testing( )

    add_custom_target( testit COMMAND ${CMAKE_CTEST_COMMAND} )
    add_dependencies( testit date-tz )

    function( add_pass_tests TEST_GLOB TEST_PREFIX )
        file( GLOB_RECURSE FILENAMES ${TEST_GLOB} )

        foreach( TEST_FILE ${FILENAMES} )
            get_filename_component( TEST_NAME ${TEST_FILE} NAME_WE )
            get_filename_component( TEST_EXT ${TEST_FILE} EXT )
            if( NOT ${TEST_EXT} STREQUAL ".fail.cpp" )
                set( PREFIX "${TEST_PREFIX}_pass_${TEST_NAME}" )
                set( BIN_NAME ${PREFIX}_bin )
                set( TST_NAME ${PREFIX}_test )
                add_executable( ${BIN_NAME} EXCLUDE_FROM_ALL ${TEST_FILE} )
                add_test( ${TST_NAME} ${BIN_NAME} )
                target_link_libraries( ${BIN_NAME} date-tz )
                # HACK: because the test files don't use FQ includes:
                target_include_directories( ${BIN_NAME} PRIVATE include/date )
                add_dependencies( testit ${BIN_NAME} )
            endif( )
        endforeach( )
    endfunction( )

    function( add_fail_tests TEST_GLOB TEST_PREFIX )
        file( GLOB_RECURSE FILENAMES ${TEST_GLOB} )

        foreach( TEST_FILE ${FILENAMES} )
            get_filename_component( TEST_NAME ${TEST_FILE} NAME_WE )
            get_filename_component( TEST_EXT ${TEST_FILE} EXT )

            set( TEST_TYPE "_fail" )

            set( PREFIX "${TEST_PREFIX}_fail_${TEST_NAME}" )
            set( BIN_NAME ${PREFIX}_bin )
            set( TST_NAME ${PREFIX}_test )

            set( TEST_BIN_NAME ${CMAKE_BINARY_DIR}/${BIN_NAME} )
            add_custom_target( ${BIN_NAME}
                COMMAND
                    ${PROJECT_SOURCE_DIR}/compile_fail.sh
                    ${TEST_BIN_NAME}
                    ${CMAKE_CXX_COMPILER}
                    -std=c++14
                    -L${CMAKE_BINARY_DIR}/
                    -ldate-tz
                    -I${PROJECT_SOURCE_DIR}/include
                    -I${PROJECT_SOURCE_DIR}/include/date
                    -o ${BIN_NAME}
                    ${TEST_FILE}
                WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                COMMENT ${TST_NAME} )
            add_test( ${TST_NAME} "${PROJECT_SOURCE_DIR}/test_fail.sh" ${CMAKE_BINARY_DIR}/${BIN_NAME} WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}/" )
            #set_tests_properties( ${TST_NAME} PROPERTIES WILL_FAIL TRUE)
            add_dependencies( testit ${BIN_NAME} )
        endforeach( )
    endfunction( )

    file( GLOB children RELATIVE "${PROJECT_SOURCE_DIR}/test" "${PROJECT_SOURCE_DIR}/test/*" )
    foreach( child ${children} )
        if( IS_DIRECTORY "${PROJECT_SOURCE_DIR}/test/${child}" )
            set( CUR_FOLDER "${PROJECT_SOURCE_DIR}/test/${child}" )
            add_pass_tests( "${CUR_FOLDER}/*.cpp" ${child} )
            if( NOT WIN32 )
                add_fail_tests( "${CUR_FOLDER}/*.fail.cpp" ${child} )
            endif( )
        endif( )
    endforeach( )
endif( )

## howardhinnant-date 3.0.1

=== debian/changelog ===
howardhinnant-date (3.0.1-4) unstable; urgency=medium

  * d/patches: always define PATH_MAX

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 13 Jan 2022 00:31:51 +0100

howardhinnant-date (3.0.1-3) unstable; urgency=medium

  * d/control: bump minimum required CMake version to 3.15
  * d/patches: install all headers. Closes: #1001895

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 05 Jan 2022 00:09:37 +0100

howardhinnant-date (3.0.1-2) unstable; urgency=medium

  * d/control: add Vcs fields
  * d/rules: add qa=+all option
  * d/watch: use GitHub's API

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 09 Dec 2021 15:51:10 +0100

howardhinnant-date (3.0.1-1) unstable; urgency=low

  * Initial release. Closes: #895222

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 01 Sep 2021 16:33:49 +0200

=== debian/control ===
Source: howardhinnant-date
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: cmake (>= 3.15),
               debhelper-compat (= 13),
               libcurl4-openssl-dev | libcurl-dev
Standards-Version: 4.6.0
Homepage: https://github.com/HowardHinnant/date
Vcs-Git: https://salsa.debian.org/debian/howardhinnant-date.git
Vcs-Browser: https://salsa.debian.org/debian/howardhinnant-date
Rules-Requires-Root: no

Package: libhowardhinnant-date-tz3
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: date and time library based on the C++ <chrono> header
 howardhinnant-date extends <chrono> to calendars and timezones,
 focusing on a seamless integration with the existing <chrono> library,
 type safety, performance and ease of use.
 .
 This package contains the tz library

Package: libhowardhinnant-date-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libhowardhinnant-date-tz3 (= ${binary:Version}),
         ${misc:Depends}
Description: date and time library based on the C++ <chrono> header - development files
 howardhinnant-date extends <chrono> to calendars and timezones,
 focusing on a seamless integration with the existing <chrono> library,
 type safety, performance and ease of use.
 .
 This package contains the development headers of the library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all qa=+all
export LC_ALL = C.UTF-8

# CXX is used by test/testit
export DPKG_EXPORT_BUILDTOOLS = 1
include /usr/share/dpkg/buildtools.mk

%:
	dh $@

# COMPILE_WITH_C_LOCALE needed because of
# https://github.com/HowardHinnant/date/issues/388
override_dh_auto_configure:
	dh_auto_configure -- \
		  -DUSE_SYSTEM_TZ_DB=ON \
		  -DBUILD_SHARED_LIBS=ON \
		  -DBUILD_TZ_LIB=ON \
		  -DCOMPILE_WITH_C_LOCALE=ON

override_dh_auto_test:
	cd test && OPTIONS='-DONLY_C_LOCALE=1 -DUSE_OS_TZDB=1' ./testit

=== debian/watch ===
version=4
opts="searchmode=plain, \
  filenamemangle=s/.+\/v@ANY_VERSION@/@PACKAGE@-$1\.tar\.gz/, \
  pgpmode=none" \
https://api.github.com/repos/HowardHinnant/date/tags \
https://api.github.com/repos/HowardHinnant/date/tarball/refs/tags/v@ANY_VERSION@

## howardhinnant-date 3.0.1%2Bds

=== debian/control ===
Source: howardhinnant-date
Section: libs
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: debhelper-compat (= 13)
Build-Depends-Arch: cmake (>= 3.15), tzdata <!nocheck>
Standards-Version: 4.6.1
Homepage: https://github.com/HowardHinnant/date
Vcs-Git: https://salsa.debian.org/debian/howardhinnant-date.git
Vcs-Browser: https://salsa.debian.org/debian/howardhinnant-date
Rules-Requires-Root: no

Package: libdate-tz3
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: tzdata, ${misc:Depends}, ${shlibs:Depends}
Description: date and time library based on the C++ <chrono> header
 howardhinnant-date extends <chrono> to calendars and timezones,
 focusing on a seamless integration with the existing <chrono> library,
 type safety, performance and ease of use.
 .
 This package contains the date-tz library

Package: libhowardhinnant-date-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libdate-tz3 (= ${binary:Version}), ${misc:Depends}
Description: date and time library based on the C++ <chrono> header - development files
 howardhinnant-date extends <chrono> to calendars and timezones,
 focusing on a seamless integration with the existing <chrono> library,
 type safety, performance and ease of use.
 .
 This package contains the development headers of the library.

=== debian/tests/control ===
Tests: cmake
Depends: cmake, g++ | c++-compiler, tzdata, @

## howardhinnant-date 3.0.1+ds

=== debian/changelog ===
howardhinnant-date (3.0.1+ds-5build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 16:49:53 +0200

howardhinnant-date (3.0.1+ds-5) unstable; urgency=medium

  * d/rules: enable Large File Support (LFS) (Closes: #1028304)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 11 Jan 2023 12:02:29 +0100

howardhinnant-date (3.0.1+ds-4) unstable; urgency=medium

  * d/control: depend on tzdata (Closes: #1027913)
  * d/patches: support dark color scheme in documentation

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sat, 07 Jan 2023 23:15:41 +0100

howardhinnant-date (3.0.1+ds-3) unstable; urgency=medium

  * d/control: explicitly build-depend on tzdata
  * d/patches: always mark HAS_STRING_VIEW as part of the interface.
    If the library gets compiled with HAS_STRING_VIEW=1, consumers always
    need to link to the functions using std::string_view, as they are the
    only ones compiled into the shared library.
    If the library gets compiled with e.g. C++17 and the user uses an older
    standard version they'll still get an error, but an helpful compile-time
    one suggesting to enable C++17 mode, instead of a cryptic linking error.
  * d/tests: fix cmake autopkgtest on bullseye

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 21 Dec 2022 17:44:00 +0100

howardhinnant-date (3.0.1+ds-2) unstable; urgency=medium

  * d/patches: refresh PATH_MAX patch

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 19 Oct 2022 10:05:44 +0200

howardhinnant-date (3.0.1+ds-1) unstable; urgency=medium

  * New upstream version 3.0.1+ds
  * d/copyright: exclude bundled tzdata
  * d/.docs: install full documentation
  * d/gbp.conf: disable pristine-tar.
    It doesn't seem to work with MUT.
  * d/rules: make use of GCC Visibility.
    The library is now compiled with -fvisibility=hidden and
    -fvisibility-inlines-hidden, and symbols are selectively exposed in the
    shared object by making use of upstream's already existing support for
    Windows' dllexport.
  * d/watch: download documentation component

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 25 Sep 2022 01:47:00 +0200

howardhinnant-date (3.0.1-7) unstable; urgency=medium

  * d/tests/cmake: suppress psABI warning on ARM

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 28 Aug 2022 21:28:50 +0200

howardhinnant-date (3.0.1-6) unstable; urgency=medium

  * Source-only upload.

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 24 Aug 2022 17:11:01 +0200

howardhinnant-date (3.0.1-5) unstable; urgency=medium

  * d/patches: drop cmake-rename patch.
    It creates more problems than it solves.
    The patch only modified the name of libraries, targets and namespaces
    in CMake, but did not touch headers. This caused problems for CMake
    users, that had to account for the "Debian name" of the library, while
    not solving name clashes where needed the most, i.e. in header files.
    The libhowardhinnant-date-dev package will keep its name, as libdate-dev
    is too general for a package name, and adding the howardhinnant prefix
    there doesn't create issues in users' code.
    As the date-tz target is no longer renamed, the shared library changed
    name from libhowardhinnant-date-tz to libdate-tz, and the binary package
    containing it did as well. (Closes: #1011640)
  * d/patches: stop using PATH_MAX.
    This will properly fix the build on GNU Hurd, while also improving the
    code on all the other platforms.

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sat, 06 Aug 2022 13:58:26 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: howardhinnant-date
 Section: libs
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
 Build-Depends: debhelper-compat (= 13)
 Build-Depends-Arch: cmake (>= 3.15), tzdata <!nocheck>
@@ -15,7 +15,9 @@
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Depends: tzdata, ${misc:Depends}, ${shlibs:Depends}
+Depends: tzdata,
+         ${misc:Depends},
+         ${shlibs:Depends}
 Description: date and time library based on the C++ <chrono> header
  howardhinnant-date extends <chrono> to calendars and timezones,
  focusing on a seamless integration with the existing <chrono> library,
@@ -28,7 +30,8 @@
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libdate-tz3 (= ${binary:Version}), ${misc:Depends}
+Depends: libdate-tz3 (= ${binary:Version}),
+         ${misc:Depends}
 Description: date and time library based on the C++ <chrono> header - development files
  howardhinnant-date extends <chrono> to calendars and timezones,
  focusing on a seamless integration with the existing <chrono> library,

=== debian/watch ===
version=4
opts="searchmode=plain, \
  filenamemangle=s/.+\/v@ANY_VERSION@/@PACKAGE@-$1\.tar\.gz/, \
  pgpmode=none, \
  repacksuffix=+ds, \
  dversionmangle=auto" \
https://api.github.com/repos/HowardHinnant/date/tags \
https://api.github.com/repos/HowardHinnant/date/tarball/refs/tags/v@ANY_VERSION@

opts="mode=git, \
  component=docs, \
  pgpmode=none" \
https://github.com/HowardHinnant/date.git \
refs/heads/(gh-pages) \
ignore uupdate

## howardhinnant-date 3.0.3%2Bds

=== debian/changelog ===
howardhinnant-date (3.0.3+ds-1) unstable; urgency=low

  * New upstream version 3.0.3+ds
  * Upload to unstable
  * d/patches: refresh headers install patch(es)
  * d/.symbols: add new symbols
  * d/watch: revert to using tags

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 21 Oct 2024 14:17:46 +0200

howardhinnant-date (3.0.1.59.gac0c58d+ds-1) experimental; urgency=low

  * New upstream version 3.0.1.59.gac0c58d+ds
  * First dgit upload
  * d/watch: switch to Git snapshots
  * d/gbp.conf: re-enable pristine-tar
  * d/patches: drop upstreamed patches
  * d/patches: update cmake-install-all-headers patch

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 29 Sep 2024 18:40:48 +0200

## howardhinnant-date 3.0.3+ds

=== debian/changelog ===
howardhinnant-date (3.0.3+ds-2) unstable; urgency=low

  * d/control: use my @debian.org email address
  * d/README.source: document packaging workflow

 -- Andrea Pappacoda <tachi@debian.org>  Wed, 09 Apr 2025 18:10:27 +0200

=== debian/control ===
Source: howardhinnant-date
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <tachi@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-build-api (= 1),
Build-Depends-Arch:
 cmake (>= 3.15),
 tzdata <!nocheck>,
Standards-Version: 4.7.2
Homepage: https://github.com/HowardHinnant/date
Vcs-Git: https://salsa.debian.org/debian/howardhinnant-date.git
Vcs-Browser: https://salsa.debian.org/debian/howardhinnant-date
X-Style: black

Package: libdate-tz3
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 tzdata,
 ${misc:Depends},
 ${shlibs:Depends},
Description: date and time library based on the C++ <chrono> header
 howardhinnant-date extends <chrono> to calendars and timezones,
 focusing on a seamless integration with the existing <chrono> library,
 type safety, performance and ease of use.
 .
 This package contains the date-tz library

Package: libhowardhinnant-date-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libdate-tz3 (= ${binary:Version}),
 ${misc:Depends},
Description: date and time library based on the C++ <chrono> header - development files
 howardhinnant-date extends <chrono> to calendars and timezones,
 focusing on a seamless integration with the existing <chrono> library,
 type safety, performance and ease of use.
 .
 This package contains the development headers of the library.

=== debian/rules ===
#!/usr/bin/make -f

# future=+lfs required because of bug #1028304
# optimize=-lto because I use CMake's LTO
export DEB_BUILD_MAINT_OPTIONS = future=+lfs hardening=+all optimize=-lto qa=+all
# To export symbols, see include/date/tz.h:130
export DEB_CPPFLAGS_MAINT_APPEND = -DDATE_BUILD_DLL
export LC_ALL = C.UTF-8

# CXX is used by test/testit
export DPKG_EXPORT_BUILDTOOLS = 1
include /usr/share/dpkg/buildtools.mk

%:
	dh $@

# COMPILE_WITH_C_LOCALE needed because of
# https://github.com/HowardHinnant/date/issues/388
override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INTERPROCEDURAL_OPTIMIZATION=ON \
		-DCMAKE_POLICY_DEFAULT_CMP0069=NEW \
		-DCMAKE_CXX_VISIBILITY_PRESET=hidden \
		-DCMAKE_VISIBILITY_INLINES_HIDDEN=ON \
		-DUSE_SYSTEM_TZ_DB=ON \
		-DBUILD_SHARED_LIBS=ON \
		-DBUILD_TZ_LIB=ON \
		-DCOMPILE_WITH_C_LOCALE=ON

override_dh_auto_test:
	cd test && OPTIONS="$(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -DONLY_C_LOCALE=1 -DUSE_OS_TZDB=1" VERBOSE=true ./testit

=== debian/tests/control ===
Tests:
 cmake,
Depends:
 cmake,
 g++ | c++-compiler,
 tzdata,
 @,
